;; Pinaret - Static website generator
;; Copyright (C) 2016  Josep Portella Florit <hello@josep-portella.com>
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

#lang racket

(define-syntax define-syntax/provide
  (syntax-rules ()
    [(_ (sym args) exps ...)
     (define-syntax/provide sym (λ (args) exps ...))]
    [(_ sym exp)
     (begin (define-syntax sym exp)
            (provide sym))]))

(provide define-syntax/provide)

(define-syntax/provide define/provide
  (syntax-rules ()
    [(_ (sym . formals) exps ...)
     (define/provide sym (λ formals exps ...))]
    [(_ sym exp)
     (begin (define sym exp)
            (provide sym))]))
